module DavinciRubyClientSDK
  class Blueprint

    attr_accessor :tag, :layers, :tmp_layer, :tmp_inspiration

    def initialize(tag)
      @blueprint = Hash.new
      @layers    = Array.new
      self.tag   = tag
    end

    def add_layer(index)
      self.tmp_layer         = Hash.new
      self.tmp_inspiration   = Hash.new
      self.tmp_layer[:layer] = index

      yield self if block_given?

      self.tmp_layer[:inspiration] = self.tmp_inspiration

      @layers << self.tmp_layer

      self.tmp_layer       = nil
      self.tmp_inspiration = nil
    end

    def canvas
      @canvas ||= Hash.new
      yield self if block_given?
      @canvas
    end

    def add_canvas_option(key, value)
      @canvas[key.to_sym] = value
    end

    def mount
      @mount ||= Hash.new
      yield self if block_given?
      @mount
    end

    def add_mount_option(key, value)
      @mount[key.to_sym] = value
    end

    def technique=(value)
      self.tmp_layer[:technique] = value.to_s
    end

    def inspiration=(value = {})
      self.tmp_inspiration = value
    end

    def add_inspiration(key, value)
      self.tmp_inspiration[key.to_sym] = value
    end

    def to_blueprint
      {
          :tag    => @tag,
          :layers => @layers,
          :canvas => @canvas,
          :mount  => @mount
      }
    end

  end
end
